% ***************************************************************
% author:   Xin Li                                             **
% date:     04/12/2013                                         **
% modified: 01/13/2015                                         **
% purpose:  convert an image to the array of patches           **
% input:    im: target image                                   **
%           par: parameters                                    **
% output:   X: patch array                                     **
% ***************************************************************

function  X  =  Im2Patch( im, par )
f       =   par.win;
N       =   size(im,1)-f+1;
M       =   size(im,2)-f+1;
L       =   N*M;
X       =   zeros(f*f, L, 'single');
k       =   0;
for i  = 1:f
    for j  = 1:f
        k    =  k+1;
        blk  =  im(i:end-f+i,j:end-f+j);
        X(k,:) =  blk(:)';
    end
end